
%{

//standard includes
#include <stdio.h>
#include <string.h>

//token ids from the parser
#ifdef LEXFLAG
#include "y.tab.h"
#else
#include "re.tab.h"
#endif

//parse from the first command-line argument
#undef YY_INPUT
#define YY_INPUT(b, r, ms) (r = my_yyinput(b, ms))

//get rid of funny extra character
#undef ECHO
#define ECHO ""

//variables for parsing from the command-line
extern char *theInput;
extern char *theInputPtr;
extern char *theInputLim;

//my own min function
int min(int a, int b) {
	if (a < b)
		return a;
	return b;
}

//function for parsing from the command-line
int my_yyinput(char *buf, int max_size) {
	int n = min(max_size, theInputLim - theInputPtr);
	if (n > 0) {
		memcpy(buf, theInput, n);
		theInputPtr += n;
	}
	return n;
}

%}

%%

[a-zA-Z0-9@]		yylval.c = yytext[0]; return SYMBOL;
"*"					return STAR;
"("					return LPAR;
")"					return RPAR;
"|"					return TIE;
\n						/* ignore end of line */;
[ \t]+				/* ignore whitespace */;

%%

